//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
// import tinymce from 'vue-tinymce-editor';
var script = {
  name: 'DynamicForms',
  props: {
    hidden: '',
    values: {
      type: Object,
      "default": function _default() {
        return {
          name: 'This is my name',
          text: 'This is my Text'
        };
      }
    },
    form: {
      type: Array,
      "default": function _default() {
        return [{
          name: 'Name',
          placeholder: 'Please Write Your Name...',
          "class": 'form-control',
          column: 'name',
          type: 'text',
          value: 'test'
        }, {
          name: 'Name Two',
          placeholder: 'Please Write Your Name...',
          "class": 'form-control',
          column: 'text',
          type: 'textarea',
          value: 'Text Area'
        }];
      }
    },
    title: {
      type: String,
      "default": 'Your Title'
    },
    button: {
      type: Object,
      "default": function _default() {
        return {
          title: 'My Button',
          "class": 'btn btn-success btn-block'
        };
      }
    },
    theme: {
      type: String,
      "default": 'dark'
    }
  },
  model: {
    prop: 'hidden',
    event: 'update'
  },
  components: {// tinymce,
  },
  data: function data() {
    return {
      formBack: []
    };
  },
  created: function created() {
    this.formBack = this.values;
  },
  methods: {
    action: function action() {
      this.$emit('save', this.formBack);
    }
  },
  computed: {},
  watch: {
    formBack: {
      handler: function handler() {
        this.$emit('update', this.formBack);
      },
      deep: true
    }
  }
};

function normalizeComponent(template, style, script, scopeId, isFunctionalTemplate, moduleIdentifier /* server only */, shadowMode, createInjector, createInjectorSSR, createInjectorShadow) {
    if (typeof shadowMode !== 'boolean') {
        createInjectorSSR = createInjector;
        createInjector = shadowMode;
        shadowMode = false;
    }
    // Vue.extend constructor export interop.
    const options = typeof script === 'function' ? script.options : script;
    // render functions
    if (template && template.render) {
        options.render = template.render;
        options.staticRenderFns = template.staticRenderFns;
        options._compiled = true;
        // functional template
        if (isFunctionalTemplate) {
            options.functional = true;
        }
    }
    // scopedId
    if (scopeId) {
        options._scopeId = scopeId;
    }
    let hook;
    if (moduleIdentifier) {
        // server build
        hook = function (context) {
            // 2.3 injection
            context =
                context || // cached call
                    (this.$vnode && this.$vnode.ssrContext) || // stateful
                    (this.parent && this.parent.$vnode && this.parent.$vnode.ssrContext); // functional
            // 2.2 with runInNewContext: true
            if (!context && typeof __VUE_SSR_CONTEXT__ !== 'undefined') {
                context = __VUE_SSR_CONTEXT__;
            }
            // inject component styles
            if (style) {
                style.call(this, createInjectorSSR(context));
            }
            // register component module identifier for async chunk inference
            if (context && context._registeredComponents) {
                context._registeredComponents.add(moduleIdentifier);
            }
        };
        // used by ssr in case component is cached and beforeCreate
        // never gets called
        options._ssrRegister = hook;
    }
    else if (style) {
        hook = shadowMode
            ? function (context) {
                style.call(this, createInjectorShadow(context, this.$root.$options.shadowRoot));
            }
            : function (context) {
                style.call(this, createInjector(context));
            };
    }
    if (hook) {
        if (options.functional) {
            // register for functional component in vue file
            const originalRender = options.render;
            options.render = function renderWithStyleInjection(h, context) {
                hook.call(context);
                return originalRender(h, context);
            };
        }
        else {
            // inject component registration as beforeCreate hook
            const existing = options.beforeCreate;
            options.beforeCreate = existing ? [].concat(existing, hook) : [hook];
        }
    }
    return script;
}

const isOldIE = typeof navigator !== 'undefined' &&
    /msie [6-9]\\b/.test(navigator.userAgent.toLowerCase());
function createInjector(context) {
    return (id, style) => addStyle(id, style);
}
let HEAD;
const styles = {};
function addStyle(id, css) {
    const group = isOldIE ? css.media || 'default' : id;
    const style = styles[group] || (styles[group] = { ids: new Set(), styles: [] });
    if (!style.ids.has(id)) {
        style.ids.add(id);
        let code = css.source;
        if (css.map) {
            // https://developer.chrome.com/devtools/docs/javascript-debugging
            // this makes source maps inside style tags work properly in Chrome
            code += '\n/*# sourceURL=' + css.map.sources[0] + ' */';
            // http://stackoverflow.com/a/26603875
            code +=
                '\n/*# sourceMappingURL=data:application/json;base64,' +
                    btoa(unescape(encodeURIComponent(JSON.stringify(css.map)))) +
                    ' */';
        }
        if (!style.element) {
            style.element = document.createElement('style');
            style.element.type = 'text/css';
            if (css.media)
                style.element.setAttribute('media', css.media);
            if (HEAD === undefined) {
                HEAD = document.head || document.getElementsByTagName('head')[0];
            }
            HEAD.appendChild(style.element);
        }
        if ('styleSheet' in style.element) {
            style.styles.push(code);
            style.element.styleSheet.cssText = style.styles
                .filter(Boolean)
                .join('\n');
        }
        else {
            const index = style.ids.size - 1;
            const textNode = document.createTextNode(code);
            const nodes = style.element.childNodes;
            if (nodes[index])
                style.element.removeChild(nodes[index]);
            if (nodes.length)
                style.element.insertBefore(textNode, nodes[index]);
            else
                style.element.appendChild(textNode);
        }
    }
}

/* script */
const __vue_script__ = script;

/* template */
var __vue_render__ = function() {
  var _vm = this;
  var _h = _vm.$createElement;
  var _c = _vm._self._c || _h;
  return _c("div", { attrs: { id: "addComponent" } }, [
    _c(
      "div",
      {
        class:
          "card " +
          (_vm.theme == "dark" ? "text-white bg-dark" : "text-black bg-white")
      },
      [
        _c("div", {
          staticClass: "card-header",
          domProps: { innerHTML: _vm._s(_vm.title) }
        }),
        _vm._v(" "),
        _c("div", { staticClass: "card-body" }, [
          _c(
            "form",
            {
              on: {
                submit: function($event) {
                  $event.preventDefault();
                  return _vm.action()
                }
              }
            },
            [
              _vm._l(_vm.form, function(f) {
                return _c("div", { key: f.name, staticClass: "form-group" }, [
                  f.type != "editor"
                    ? _c("div", { staticClass: "row" }, [
                        _c("div", { staticClass: "col-md-3" }, [
                          _c("label", { attrs: { for: f.column } }, [
                            _vm._v(_vm._s(f.name))
                          ])
                        ]),
                        _vm._v(" "),
                        _c("div", { staticClass: "col-md-9" }, [
                          f.type === "checkbox" &&
                          f.type != "selectbox" &&
                            f.type != "textarea" &&
                            f.type != "editor"
                            ? _c("input", {
                                directives: [
                                  {
                                    name: "model",
                                    rawName: "v-model",
                                    value: _vm.formBack[f.column],
                                    expression: "formBack[f.column]"
                                  }
                                ],
                                class: f.class,
                                attrs: {
                                  required: f.required ? "" : false,
                                  placeholder: f.placeholder,
                                  id: f.column,
                                  type: "checkbox"
                                },
                                domProps: {
                                  checked: Array.isArray(_vm.formBack[f.column])
                                    ? _vm._i(_vm.formBack[f.column], null) > -1
                                    : _vm.formBack[f.column]
                                },
                                on: {
                                  change: function($event) {
                                    var $$a = _vm.formBack[f.column],
                                      $$el = $event.target,
                                      $$c = $$el.checked ? true : false;
                                    if (Array.isArray($$a)) {
                                      var $$v = null,
                                        $$i = _vm._i($$a, $$v);
                                      if ($$el.checked) {
                                        $$i < 0 &&
                                          _vm.$set(
                                            _vm.formBack,
                                            f.column,
                                            $$a.concat([$$v])
                                          );
                                      } else {
                                        $$i > -1 &&
                                          _vm.$set(
                                            _vm.formBack,
                                            f.column,
                                            $$a
                                              .slice(0, $$i)
                                              .concat($$a.slice($$i + 1))
                                          );
                                      }
                                    } else {
                                      _vm.$set(_vm.formBack, f.column, $$c);
                                    }
                                  }
                                }
                              })
                            : f.type === "radio" &&
                              f.type != "selectbox" &&
                                f.type != "textarea" &&
                                f.type != "editor"
                            ? _c("input", {
                                directives: [
                                  {
                                    name: "model",
                                    rawName: "v-model",
                                    value: _vm.formBack[f.column],
                                    expression: "formBack[f.column]"
                                  }
                                ],
                                class: f.class,
                                attrs: {
                                  required: f.required ? "" : false,
                                  placeholder: f.placeholder,
                                  id: f.column,
                                  type: "radio"
                                },
                                domProps: {
                                  checked: _vm._q(_vm.formBack[f.column], null)
                                },
                                on: {
                                  change: function($event) {
                                    return _vm.$set(
                                      _vm.formBack,
                                      f.column,
                                      null
                                    )
                                  }
                                }
                              })
                            : f.type != "selectbox" &&
                              f.type != "textarea" &&
                              f.type != "editor"
                            ? _c("input", {
                                directives: [
                                  {
                                    name: "model",
                                    rawName: "v-model",
                                    value: _vm.formBack[f.column],
                                    expression: "formBack[f.column]"
                                  }
                                ],
                                class: f.class,
                                attrs: {
                                  required: f.required ? "" : false,
                                  placeholder: f.placeholder,
                                  id: f.column,
                                  type: f.type
                                },
                                domProps: { value: _vm.formBack[f.column] },
                                on: {
                                  input: function($event) {
                                    if ($event.target.composing) {
                                      return
                                    }
                                    _vm.$set(
                                      _vm.formBack,
                                      f.column,
                                      $event.target.value
                                    );
                                  }
                                }
                              })
                            : f.type == "textarea"
                            ? _c("textarea", {
                                directives: [
                                  {
                                    name: "model",
                                    rawName: "v-model",
                                    value: _vm.formBack[f.column],
                                    expression: "formBack[f.column]"
                                  }
                                ],
                                class: f.class,
                                attrs: {
                                  required: f.required ? "" : false,
                                  placeholder: f.placeholder,
                                  id: f.column
                                },
                                domProps: { value: _vm.formBack[f.column] },
                                on: {
                                  input: function($event) {
                                    if ($event.target.composing) {
                                      return
                                    }
                                    _vm.$set(
                                      _vm.formBack,
                                      f.column,
                                      $event.target.value
                                    );
                                  }
                                }
                              })
                            : _c(
                                "select",
                                {
                                  directives: [
                                    {
                                      name: "model",
                                      rawName: "v-model",
                                      value: _vm.formBack[f.column],
                                      expression: "formBack[f.column]"
                                    }
                                  ],
                                  class: f.class,
                                  attrs: {
                                    type: f.type,
                                    required: f.required ? "" : false,
                                    id: f.column
                                  },
                                  on: {
                                    change: function($event) {
                                      var $$selectedVal = Array.prototype.filter
                                        .call($event.target.options, function(
                                          o
                                        ) {
                                          return o.selected
                                        })
                                        .map(function(o) {
                                          var val =
                                            "_value" in o ? o._value : o.value;
                                          return val
                                        });
                                      _vm.$set(
                                        _vm.formBack,
                                        f.column,
                                        $event.target.multiple
                                          ? $$selectedVal
                                          : $$selectedVal[0]
                                      );
                                    }
                                  }
                                },
                                _vm._l(f.items, function(v) {
                                  return _c(
                                    "option",
                                    {
                                      key: v[f.value],
                                      domProps: { value: v[f.value] }
                                    },
                                    [
                                      _vm._v(
                                        "\n                                    " +
                                          _vm._s(v[f.show]) +
                                          "\n                                "
                                      )
                                    ]
                                  )
                                }),
                                0
                              )
                        ])
                      ])
                    : _c("div", [
                        _c("label", { attrs: { for: f.column } }, [
                          _vm._v(_vm._s(f.name))
                        ]),
                        _vm._v(" "),
                        _c("div", {
                          domProps: {
                            innerHTML: _vm._s(_vm.formBack[f.column])
                          }
                        })
                      ])
                ])
              }),
              _vm._v(" "),
              _c("div", { staticClass: "form-group row mb-0" }, [
                _c("div", { staticClass: "col-md-6 offset-md-3" }, [
                  _c("button", {
                    class: _vm.button.class,
                    attrs: { type: "submit" },
                    domProps: { innerHTML: _vm._s(_vm.button.title) }
                  })
                ])
              ])
            ],
            2
          )
        ])
      ]
    )
  ])
};
var __vue_staticRenderFns__ = [];
__vue_render__._withStripped = true;

  /* style */
  const __vue_inject_styles__ = function (inject) {
    if (!inject) return
    inject("data-v-87f062dc_0", { source: "\n@import './../styles/style.css';\r\n", map: {"version":3,"sources":["C:\\xampp\\htdocs\\vue-plugin\\src\\components\\DynamicForms.vue"],"names":[],"mappings":";AAkIA,+BAAA","file":"DynamicForms.vue","sourcesContent":["<template>\r\n    <div id=\"addComponent\">\r\n        <div :class=\"`card ${theme == 'dark' ? 'text-white bg-dark' : 'text-black bg-white'}`\">\r\n            <div class=\"card-header\" v-html=\"title\"></div>\r\n            <div class=\"card-body\">\r\n                <form @submit.prevent=\"action()\">\r\n                    <div class=\"form-group\" v-for=\"f in form\" v-bind:key=\"f.name\">\r\n                        <div class=\"row\" v-if=\"f.type != 'editor'\">\r\n                            <div class=\"col-md-3\">\r\n                                <label :for=\"f.column\">{{f.name}}</label>\r\n                            </div>\r\n                            <div class=\"col-md-9\">\r\n                                <input v-if=\"f.type != 'selectbox' && f.type != 'textarea' && f.type != 'editor'\" :type=\"f.type\" :required=\"f.required ? '' : false\" :placeholder=\"f.placeholder\" v-model=\"formBack[f.column]\" :id=\"f.column\" :class=\"f.class\">\r\n                                <textarea v-else-if=\"f.type == 'textarea'\" :required=\"f.required ? '' : false\" :placeholder=\"f.placeholder\" v-model=\"formBack[f.column]\" :id=\"f.column\" :class=\"f.class\"></textarea>\r\n                                <select v-else :type=\"f.type\" :required=\"f.required ? '' : false\" v-model=\"formBack[f.column]\" :id=\"f.column\" :class=\"f.class\">\r\n                                    <option v-for=\"v in f.items\" v-bind:key=\"v[f.value]\" :value=\"v[f.value]\">\r\n                                        {{v[f.show]}}\r\n                                    </option>\r\n                                </select>\r\n                            </div>\r\n                        </div>\r\n                        <div v-else>\r\n                            <label :for=\"f.column\">{{f.name}}</label>\r\n                            <!-- <tinymce v-model=\"formBack[f.column]\" :id=\"f.column\" class=\"tinymce\"></tinymce> -->\r\n                            <div v-html=\"formBack[f.column]\"></div>\r\n                        </div>\r\n                    </div>\r\n                    <div class=\"form-group row mb-0\">\r\n                        <div class=\"col-md-6 offset-md-3\">\r\n                            <button type=\"submit\" :class=\"button.class\" v-html=\"button.title\"></button>\r\n                        </div>\r\n                    </div>\r\n                </form>\r\n            </div>\r\n        </div>\r\n    </div>\r\n</template>\r\n\r\n<script>\r\n// import tinymce from 'vue-tinymce-editor';\r\n\r\nexport default {\r\n    name : 'DynamicForms',\r\n    props : {\r\n        hidden : '',\r\n        values : {\r\n            type : Object,\r\n            default(){\r\n                return{\r\n                    name : 'This is my name',\r\n                    text : 'This is my Text',\r\n                }\r\n            }\r\n        },\r\n        form : {\r\n            type : Array,\r\n            default(){\r\n                return[\r\n                    {\r\n                        name : 'Name',\r\n                        placeholder : 'Please Write Your Name...',\r\n                        class : 'form-control',\r\n                        column : 'name',\r\n                        type : 'text',\r\n                        value : 'test',\r\n                    },\r\n                    {\r\n                        name : 'Name Two',\r\n                        placeholder : 'Please Write Your Name...',\r\n                        class : 'form-control',\r\n                        column : 'text',\r\n                        type : 'textarea',\r\n                        value : 'Text Area',\r\n                    }, \r\n                ]\r\n            }\r\n        },\r\n        title : {\r\n            type : String,\r\n            default : 'Your Title'\r\n        },\r\n        button : {\r\n            type : Object,\r\n            default(){\r\n                return {\r\n                    title : 'My Button',\r\n                    class : 'btn btn-success btn-block'\r\n                }\r\n            }\r\n        },\r\n        theme : {\r\n            type : String,\r\n            default : 'dark',\r\n        }\r\n    },\r\n    model: {\r\n        prop: 'hidden',\r\n        event: 'update'\r\n    },\r\n    components : {\r\n        // tinymce,\r\n    },\r\n    data(){\r\n        return{\r\n            formBack : [],\r\n        }\r\n    },\r\n    created(){\r\n        this.formBack = this.values;\r\n    },\r\n    methods : {\r\n        action(){\r\n            this.$emit('save' , this.formBack);\r\n        }\r\n    },\r\n    computed : {\r\n\r\n    },\r\n    watch : {\r\n        formBack : {\r\n            handler(){\r\n                this.$emit('update' , this.formBack);\r\n            },\r\n            deep : true,\r\n        }\r\n    }\r\n}\r\n</script>\r\n\r\n<style scoped>\r\n@import './../styles/style.css';\r\n</style>\r\n"]}, media: undefined });

  };
  /* scoped */
  const __vue_scope_id__ = "data-v-87f062dc";
  /* module identifier */
  const __vue_module_identifier__ = undefined;
  /* functional template */
  const __vue_is_functional_template__ = false;
  /* style inject SSR */
  
  /* style inject shadow dom */
  

  
  const __vue_component__ = normalizeComponent(
    { render: __vue_render__, staticRenderFns: __vue_staticRenderFns__ },
    __vue_inject_styles__,
    __vue_script__,
    __vue_scope_id__,
    __vue_is_functional_template__,
    __vue_module_identifier__,
    false,
    createInjector,
    undefined,
    undefined
  );

export default __vue_component__;
